#include	<stddef.h>
#include	<ctype.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

#include	"mckc.h"

extern void splitPath( char *ptr, char *path, char *name, char *ext );
extern void makePath(  char *ptr, char *path, char *name, char *ext );
extern char *skipSpace( char *ptr );
extern char *patchstr;
extern char *hogereleasestr;

char	fname[2][256];
int		debug_flag = 0;
char	ef_name[256]  = "effect.h";
char	inc_name[256] = "define.inc";
int		ef_out_flag = 1;
int		warning_flag = 1;
int		include_flag = 0;
extern	int data_make( void );
extern	int		message_flag;			// \bZ[W̏o͐ݒ( 0:Jp 1:En )

/*--------------------------------------------------------------
	wv\
 Input:

 Output:

--------------------------------------------------------------*/
void dispHelpMessage( void )
{
	if( message_flag == 0 ) {
#ifdef __MINGW32__
		puts(	"gp@:mckc [switch] <Input File[.MUS]> [<Output File[.h]>]\n"
				"\t[switch]\n"
				"\t-h -?   : wv\\\n"
				"\t-i      : F/Gx[vt@Cɋȃf[^ǉ\n"
				"\t-m<num> : G[/[jO\\̑I(0:Jp 1:En)\n"
				"\t-n      : F/Gx[vt@Co͂Ȃ\n"
				"\t-o<str> : F/Gx[vt@C̃t@C<str>ɂ\n"
				"\t-w      : WarningbZ[W\\܂\n"
	    );
#else
		puts(	"gp@:mckc [switch] <Input File[.MUS]> [<Output File[.h]>]\n"
				"\t[switch]\n"
				"\t-h -?   : wv\\n"
				"\t-i      : F/Gx[vt@Cɋȃf[^ǉ\n"
				"\t-m<num> : G[/[jO\̑I(0:Jp 1:En)\n"
				"\t-n      : F/Gx[vt@Co͂Ȃ\n"
				"\t-o<str> : F/Gx[vt@C̃t@C<str>ɂ\n"
				"\t-w      : WarningbZ[W\܂\n"
	    );
#endif

	} else {
		puts(	"usage:mckc [switch] <Input File[.MUS]> [<Output File[.h]>]\n"
				"\t[switch]\n"
				"\t-h -?   : Disp this help message\n"
				"\t-i      : Including song data in tone/envelope file\n"
				"\t-m<num> : Disp languege select Error/Warning message(0:Jp 1:En)\n"
				"\t-n      : Don't output tone/envelope file\n"
				"\t-o<str> : Output tone/Envelope file name is <str>\n"
				"\t-w      : Don't disp Warning message\n"
	    );
	}
	exit( 1 );
}



/*--------------------------------------------------------------
	C[`
 Input:
	int  argc		: R}hČ
	char *argv[]	: R}hC̃|C^
 Output:
	0:I 0:ȊOȏI
--------------------------------------------------------------*/
int main( int argc , char *argv[] )
{
	int	i,in,out;
	char	path[256],name[256],ext[256];

	in = out = 0;

// ^Cg\
	printf( "MML to MCK Data Converter Ver %d.%02d by Manbow-J\npmck modification by BKC rel 0.2\n",
			(VersionNo/100), (VersionNo%100) );
	//printf("patches by [OK] and 2ch mck thread people\n");
	printf(patchstr);
	printf(hogereleasestr);
// R}hC
	if( argc == 1 ) {
		dispHelpMessage();
		return -1;
	}

	for ( i = 1; i < argc; i++ ) {
		// XCb`H
		if ( (argv[i][0] == '-') || (argv[i][0] == '/') ) {
			switch( toupper( argv[i][1] ) ) {
			  case 'H':
			  case '?':
				dispHelpMessage();
				return 1;
			  case 'X':
				debug_flag = 1;
				break;
			  case 'I':
				include_flag = 1;
				break;
			  case 'M':
				message_flag = atoi( &(argv[i][2]) );
				if( message_flag > 1 ) {
					dispHelpMessage();
					return 1;
				}
				break;
			  case 'N':
				ef_out_flag = 0;
				break;
			  case 'O':
				strcpy( ef_name, skipSpace( &(argv[i][2]) ) );
				break;
			  case 'W':
				warning_flag = 0;
				break;
			  default:
				if( message_flag == 0 ) {
					puts( "XCb`̎w肪Ⴂ܂\n" );
				} else {
					puts( "Nothing switch!\n" );
				}
				dispHelpMessage();
				return -1;
			}
		// /o̓t@C̊i[
		} else {
			if( in < _num ) {
				strcpy( fname[in], argv[i] );
				in++;
			} else {
				if( message_flag == 0 ) {
					puts( "p[^܂\n" );
				} else {
					puts( "Too many parameters!\n" );
				}
				dispHelpMessage();
				return -1;
			}
		}
	}

	switch( in ) {
	  case 0:
		dispHelpMessage();
		return -1;
	  case 1:
		splitPath( fname[0], path, name, ext );
		makePath(  fname[1], path, name, ".h" );
		break;
	}

	printf( "%s -> %s\n" , fname[0], fname[1] );
// Ro[g
	i = data_make();
// I
	if (i == 0) {
		if( message_flag == 0 ) {
			puts( "\nI܂\n" );
		} else {
			puts( "\nCompleated!\n" );
		}
		return EXIT_SUCCESS;
	} else {
		if( message_flag == 0 ) {
			puts( "\nRpCɎs܂\n" );
		} else {
			puts( "\nCompilation failed!\n" );
		}
		return EXIT_FAILURE;
	}
}
